/*----------------------------------------------------------------------------+
 |                                                                            |
 |                    Enhanced HEYU Functionality                             |
 |                                                                            |
 | Enhancements copyright 2004 Charles W. Sullivan (cwsulliv@triad.rr.com)    |
 | All Rights Reserved                                                        |
 |                                                                            |
 | Changes for use with CM11A copyright 1996, 1997 Daniel B. Suthers,         |
 | Pleasanton Ca, 94588 USA    E-mail dbs@tanj.com                            |
 |                                                                            |
 | Copyright 1986 by Larry Campbell, 73 Concord Street, Maynard MA 01754 USA  |
 | (maynard!campbell).                                                        |
 |                                                                            |
 | John Chmielewski (tesla!jlc until 9/1/86, then rogue!jlc) assisted         |
 | by doing the System V port and adding some nice features.  Thanks!         |
 |                                                                            |
 | This software is licensed free of charge for non-commercial distribution   |
 | and for personal and internal business use only.  Inclusion of this        |
 | software or any part thereof in a commercial product is prohibited         |
 | without the prior written permission of the author.  You may copy, use,    |
 | and distribute this software subject to the following restrictions:        |
 |                                                                            |
 |  1)	You may not charge money for it.                                      |
 |  2)	You may not remove or alter this license, copyright notice, or the    |
 |      included disclaimers.                                                 |
 |  3)	You may not claim you wrote it.                                       |
 |  4)	If you make improvements (or other changes), you are requested        |
 |	to send them to the official Heyu maintainer, Daniel B. Suthers       |
 |      (dbs@tanj.com), so there's a focal point for distributing improved    |
 |      versions.                                                             |
 |                                                                            |
 | As used herein, HEYU is a trademark of Daniel B. Suthers, while X10,       | 
 | CM11A, and Activehome are trademarks of X10 Wireless Technology, Inc.      |
 |                                                                            |
 | Disclaimers:                                                               |
 | THERE IS NO ASSURANCE THAT THIS SOFTWARE IS FREE OF DEFECTS AND IT MUST    |
 | NOT BE USED IN ANY SITUATION WHERE THERE IS ANY CHANCE THAT ITS            |
 | PERFORMANCE OR FAILURE TO PERFORM AS EXPECTED COULD RESULT IN LOSS OF      |
 | LIFE, INJURY TO PERSONS OR PROPERTY, FINANCIAL LOSS, OR LEGAL LIABILITY.   |
 |                                                                            |
 | TO THE EXTENT ALLOWED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED "AS IS",|
 | WITH NO EXPRESS OR IMPLIED WARRANTY, INCLUDING, BUT NOT LIMITED TO, THE    |
 | IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.|
 |                                                                            |
 | IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL THE AUTHOR BE LIABLE    |
 | FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   |
 | DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THIS SOFTWARE EVEN IF   |
 | THE AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.            |
 |                                                                            |
 +----------------------------------------------------------------------------*/

#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#if defined(SYSV) || defined(FREEBSD)
#include <string.h>
#else
#include <strings.h>
#endif
#include <time.h>
#include <signal.h>
#include "x10.h"
#include "version.h"
#include <syslog.h>
#include "process.h" 

#ifdef __GLIBC__
/* msf - added for glibc/rh 5.0 */
#include <sys/types.h>
#endif

extern int sptty;
extern CONFIG config; 
extern int i_am_monitor, i_am_state;
extern int verbose;

extern int xread(int, unsigned char *, int, int);

/*----------------------------------------------------------------------------+
 | Determine the maximum number of bytes for a received function available in |
 | the buffer.  Arguments lenbyte and fmapbyte are the first two bytes from   |
 | the buffer, representing the length of the buffer and a bitmapped function |
 | indicator.  The return value is determined by the lesser the length of the |
 | buffer or the distance to the next indicated function from the function    |
 | indicator byte.                                                            |
 +----------------------------------------------------------------------------*/
int max_funclen ( unsigned char lenbyte, unsigned char fmapbyte, int pos )
{
   int k, maxlen;

   if ( !(fmapbyte & (1 << pos)) || lenbyte > 9 )
      return 0;
   
   maxlen = 1;
   for ( k = pos + 1; k < lenbyte - 1; k++ ) {
      if ( !(fmapbyte & (1 << k)) )
         maxlen++;
      else
         break;
   }
   return maxlen;
}


/* 
 *  The CM11A sends data back to the computer whenever it sees a command
 *  come in over the AC buss.  This should (theoretically) allow the compuer
 *  to track the status of all modules.  Upon startup, this program should
 *  check for a poll before anything else.
 *
 *  Check for a poll (0x5a) from the CM11A, If we get one within a
 *  second, we should send 0xc3 to tell it that we are ready to read
 *  it's output.
 *
 *  If the showdata flag is set, we print.  Otherwise we just eat the output.
 */


char statstr[80];
unsigned char signal_source;
extern FILE *fdsout;
extern FILE *fdserr; 

int check4poll(showdata, timeout)
int showdata;
int timeout;
{
    static int lastunit;
    static char lasthc = '_';
    int temperat, fdata;
    int n, i;
    int to_read;
    char hc;
    unsigned char predim, xcmd, xdata, subunit;
    int unit;
    int macro_report;
    char *func;
    int funcbits;
    static int wasflag = 0;
    unsigned char buf[128];
    extern char *b2s();
    time_t now;
    struct tm *tp;
    off_t f_offset;
    unsigned int mac_addr, bitmap;
    extern void acknowledge_hail();
    extern int special_func;
    extern int display_expanded_macro();
    int ichksum;
    extern char *translate_sent();
    int launchp = -1;
    char *maclabel;

    static int launch_enable;
    static int chksum_alert;
    extern char *funclabel[16];
    static unsigned char newbuf[8];
    static char *send_prefix = "sndc";

    int identify_sent(char *, int);
    char *translate_other(char *, int);
    int sent_type;
    unsigned char tag;
    int maxlen;
    unsigned char level;
    static unsigned char defer_dim;
    char minibuf[32];
    static char *rcs_status[10] = {
       "System_mode = OFF", "System_mode = HEAT", "System_mode = COOL", "System_mode = AUTO",
       "Fan = ON", "Fan = OFF", "Setback = ON", "Setback = OFF", "Temp Change", "Setpoint Change"
    };

    if ( i_am_state ) {
       fdsout = freopen(config.logfile, "a", stdout);
       fdserr = freopen(config.logfile, "a", stderr);
    }
    else {
       fdsout = stdout;
       fdserr = stderr;
    }

    unit = -1;
    hc = '\0';
    func =  "" ;

    /* In case we need to spawn a child, as in heyuhelper. */
    signal(SIGCHLD, SIG_IGN);

    if ( showdata || special_func )  {
	now = 0;
	time(&now);
	tp = localtime( &now );
	sprintf(statstr, "%d/%02d/%02d %02d:%02d:%02d ",
	tp->tm_year + 1900, tp->tm_mon + 1, tp->tm_mday,
        tp->tm_hour, tp->tm_min, tp->tm_sec);
    } 

    if ( timeout == 0 )	 {	/* only do a read if there is data */
	if( sptty < 0 ) {
	    return 0;
        }
        f_offset = lseek(sptty, 0, SEEK_CUR);
	if ( f_offset == lseek(sptty, 0, SEEK_END) ) {
	    return 0;
        }
	lseek(sptty, f_offset, SEEK_SET);
	timeout = 1;
    }

    n = xread(sptty, buf, 1, timeout);
    if ( n != 0 ) {
	/* Three 0xff bytes in a row indicate that I sent a transmission to
	 * the CM11, I.E a command.  The byte following the 3 0xFF bytes
	 * indicates how long the sent command was.  We need to suck these
	 * off the stack if we are monitoring.
	 */
	while ( buf[0] == 0xff )  {  /* CM11A may be responding to a transmission  */
	    if ( ++wasflag == 3 ) {
		wasflag = 0;
		n = xread(sptty, buf, 1, timeout);	/* length of xmit */
		if( n != 1 ) {
		     return(0);
                }
		n = buf[0];

                if ( n < 127 ) {
                   n = xread(sptty, buf, n, timeout);

                   /* Identify the type of sent command from the leading */
                   /* byte and the length of the buffer.                 */
                   sent_type = identify_sent(buf, n);

                   if ( sent_type == SENT_STCMD ) {
                      /* A command for the monitor/state process */
                      if ( buf[1] == ST_LAUNCH ) {
                         launch_enable = (i_am_state) ? buf[2] : 0 ;
                         signal_source = (buf[2]) ? SNDC : SNDS ;
                         send_prefix = (buf[2]) ? "sndc" : "snds";
                      }
                      else if ( buf[1] == ST_INIT_ALL && i_am_state ) {
                         x10state_init_all();
                         write_x10state_file();
                      }
                      else if ( buf[1] == ST_INIT && i_am_state ) {
                         x10state_init(buf[2]);
                         write_x10state_file();
                      }
                      else if ( buf[1] == ST_WRITE && i_am_state ) {
                         write_x10state_file();
                      }
                      else if ( buf[1] == ST_EXIT && i_am_state ) {
                         write_x10state_file();
                         unlock_state_engine();
                         exit(0);
                      }
#if 0
                      else if ( buf[1] == ST_CHKSUM )
                         chksum_alert = buf[2];
#endif
                      else ;
                   } 
                   else if ( sent_type == SENT_WRMI ) {
                      /* WRMI - Ignore */
                   }
                   else if ( sent_type == SENT_ADDR ) {
                      /* An address */
                      fprintf(fdsout, "%s %s %s\n", statstr, send_prefix, translate_sent(buf, n, &launchp));
                      launchp = -1;
                   }
                   else if ( sent_type == SENT_FUNC ) {
                      /* Standard function */
                      fprintf(fdsout, "%s %s %s\n", statstr, send_prefix, translate_sent(buf, n, &launchp));
                      if ( launchp >= 0 && launch_enable && i_am_state) {
                         launch_script(&launchp);
                      }
                   }
                   else if ( sent_type == SENT_EXTFUNC ) {
                      /* Extended function */
                      fprintf(fdsout,"%s %s %s\n", statstr, send_prefix, translate_sent(buf, n, &launchp));
                      if ( launchp >= 0 && launch_enable && i_am_state) {
                         launch_script(&launchp);
                      }
                   }
                   else if ( sent_type == SENT_OTHER ) {
                      /* Other command */
                      fprintf(fdsout, "%s %s\n", statstr, translate_other(buf, n));
                      launchp = -1;
                   }

                }
                else {
                   n = xread(sptty, buf, n - 127, timeout);
                }
                
	        fflush(fdsout);
	        return(0);
	    }
	    else
		n = xread(sptty, buf, 1, timeout);

	    if( n != 1 ) {
	        return(0);
            }

	}   /* end of while */


	/* print out the saved 0xff from the buffer */
	if ( buf[0] != 0xff && wasflag > 0 )  {
	    n = buf[0];
	    for(i = 0; i < wasflag;i++)
		buf[i] = 0xff;
	    buf[i] = n;
	    wasflag = 0;
	}
	    
	macro_report = 0;
        if ( buf[0] == 0x5a )  {
            /* CM11A has polling info for me */
	    /* The xread is executed a second time on failure because the
	       dim commands may be tieing up the CM11.
	    */
	    n = xread(sptty, buf, 1, 2);  /* get the buffer size */
	    if ( n == 0)
		n = xread(sptty, buf, 1, 2);  /* get the buffer size */

	    if ( n > 0 )  {
                /* We have a byte count */
	        to_read = buf[0];	/* number of bytes to read */
		if ( to_read == 0x5a ) {
                    if ( chksum_alert ) {
                       /* It's the checksum for a sent block of data with checksum = 0x5a */
                       chksum_alert = 0;
                       /* fclose(fdsout); */
                       return 0;
                    }
                    else {	
                       /* Darn.  Another polling indicator */
		       timeout = 2;
		       return ( check4poll(showdata, timeout) );
                    }
		}
		else if ( to_read == 0x5b )  { /* Macro report coming in */
		    to_read = 2;
		    macro_report = 1;
		}

		if ( to_read > sizeof(buf) ) {
		    if( verbose )
			fprintf(fdserr, "Polling read size exceeds buffer");
		    return(-1);
		}

		n = xread(sptty, buf, to_read , timeout);
		if ( n != to_read ) {
		    fprintf(fdsout, "Poll only got %d of %d bytes\n",
		            n, to_read);
		    fflush(fdsout);
		    return 0;
		}

                if( showdata > 0 && (verbose != 0) )
		    fprintf(fdsout, "I received a poll %d bytes long.\n", n);

		if( macro_report == 1 )  { /* CM11A is reporting a macro execution.*/
		    if ( showdata ) {
                       mac_addr = ((buf[0] & 0x07) << 8) + buf[1];
                       /* Get macro label (or "Unknown") and saved image checksum */ 
                       maclabel = lookup_macro(mac_addr, &ichksum);

                       if ( buf[0] & 0x70 )  {
                          /* Macro was executed by a Trigger */
                          if ( ichksum != -1 && load_image(ichksum) ) {

                             /* Determine and display the inferred trigger. */
                             /* Launch a script if warranted.               */
                             signal_source = RCVT;
                             tag = (buf[0] & 0x70) >> 4;
                             display_trigger(statstr, mac_addr, tag);

                             /* Announce the execution of the macro */
                             fprintf(fdsout, "%s Trigger executed macro   : %s, address %d\n",
                                   statstr, maclabel, mac_addr);

                             /* Decipher and display macro elements from image file. */
                             /* Launch script(s) when warranted.                     */
                             signal_source = SNDT;
                             expand_macro(statstr, mac_addr, TRIGGER_EXEC);
                          }
                          else {
                             fprintf(fdsout, "%s Trigger executed macro   : %s, address %d\n",
                                    statstr, maclabel, mac_addr);
                          }
                       }
                       else {
                          /* Macro was executed by a Timer */
                          if ( ichksum != -1 && load_image(ichksum) ) {
                             fprintf(fdsout, "%s Timer executed macro     : %s, address %d\n",
                                       statstr, maclabel, mac_addr);
                             /* Decipher and display macro elements from image file. */
                             /* Launch script(s) when warranted.                     */
                             signal_source = SNDM;
                             expand_macro(statstr, mac_addr, TIMER_EXEC);
                          }
                          else {
                             fprintf(fdsout, "%s Timer executed macro     : %s, address %d\n",
                                       statstr, maclabel, mac_addr);
                          }
                       }
		    }
		}
		else {
                    signal_source = RCVI;
#if 0   			
                    if ( showdata ) {
                        for ( i = 1; i < to_read; i++)
                            fprintf(fdsout, " %02x", buf[i]);
                        fprintf(fdsout, "\n");
                    }
#endif
                       
			    
		    for ( i = 1; i < to_read; i++) {
                        xcmd = xdata = subunit = predim = level = 0;

			if ( defer_dim &&
                            ( (funcbits = (newbuf[0] & 0x0F)) == DIM || funcbits == BRIGHT) ) {
                            /* Finish handling a deferred Dim or Bright function */
                            newbuf[1] = buf[i];
                            signal_source = RCVI;
                            x10state_update_func(newbuf, &launchp);
                            hc = code2hc((newbuf[0] & 0xF0) >> 4);
                            level = buf[i];
                            defer_dim = 0;
                            newbuf[0] = 0;                            
			    if( showdata ) {
                               fprintf(fdsout, "%s rcvi function %10s : housecode %c, %s %%%02.0f [%d]\n",
                                  statstr, funclabel[funcbits], hc, 
                                  ((funcbits == DIM) ? "dimmed" : "brighten"),
                                  100.*(float)level/210., level);
                            }
			}
			else if ( (buf[0] & (0x01 << (i-1))) != 0) {
                            /* A function has been received */
                            signal_source = RCVI;

                            /* Determine the maximum number of bytes    */
                            /* available in the buffer for the function */
                            maxlen = max_funclen(to_read, buf[0], (i-1));

			    hc = code2hc( ((buf[i] & 0xF0) >> 4) );
			    funcbits = buf[i] & 0x0F;
                            func = funclabel[buf[i] & 0x0F];

			    if ( funcbits == DIM || funcbits == BRIGHT ) {
                               if ( maxlen > 1 ) {
                                  /* We have the dim level - handle it here */
                                  x10state_update_func(buf + i, &launchp);
                                  level = buf[i+1];
                                  defer_dim = 0;
                                  i++;
                               }
			       else {
                                  /* Otherwise, defer until we've got the dim level */
                                  newbuf[0] = buf[i];
                                  defer_dim = 1;
                               }
                            }
			    else if ( funcbits == PRESET1 || funcbits == PRESET2)  {
			        func = "Preset";
                                x10state_update_func(buf + i, &launchp);

                                predim = rev_low_nybble((buf[i] & 0xF0) >> 4) + 1;

			        if ( funcbits == PRESET2 )
			           predim += 16;

                                fdata = predim;
			    }
                            else if ( funcbits == EXTCODE )  {
                                if ( maxlen >= 4 )  {
                                    /* Buffer looks OK. (Sometimes it gets  */
                                    /* garbled when ext code functions are  */
                                    /* received by a firmware 1 interface.) */
                                    x10state_update_ext3func(buf + i, &launchp);
                                    unit = code2unit(buf[i+1] & 0x0f);
				    subunit = (buf[i+1] & 0xf0) >> 4;
                                    bitmap = 1 << (buf[i+1] & 0x0f);
                                    xdata = buf[i+2];
                                    xcmd = buf[i+3];
                                    i += 3;
                                }
                                else  {
                                    /* Garbled buffer - dump it */
                                    unit = 0;
                                    bitmap = 0;
                                    xdata = 0;
                                    xcmd = 0xff;
                                    i = to_read;
                                }
                            }
                            else {
                                x10state_update_func(buf + i, &launchp);
                            }
                                
				
			    if ( showdata )  {
				if ( funcbits == DIM || funcbits == BRIGHT ) {
                                    if ( !defer_dim )
                                        fprintf(fdsout, "%s rcvi function %10s : housecode %c, %s %%%02.0f [%d]\n",
                                           statstr, funclabel[funcbits], toupper(hc), 
                                           ((funcbits == DIM) ? "dimmed" : "brighten"),
                                           100.*(float)level/210., level);
                                }
				else if ( funcbits == PRESET1 || funcbits == PRESET2 ) {
				    fprintf(fdsout, "%s rcvi function %10s : level %d\n",
					    statstr, func, predim);
                                    if ( i_am_monitor &&
                                         config.rcs_temperature & (1 << hc2code(lasthc)) ) {
                                       /* Special functions for RCS compatible thermometers */
                                       if ( lastunit > 10 )  {
                                          temperat = -60 + (predim - 1) + 32 * (lastunit - 11);
					  sprintf(minibuf, "Temperature = %d", temperat);
                                          fprintf(fdsout, "%s %-24s : Location %c (%s)\n",
                                            statstr, minibuf, toupper(lasthc), alias_rev_lookup(lasthc, 0));
                                       }
                                       else if ( lastunit == 6 && predim < 11 ) {
                                          fprintf(fdsout, "%s %-24s : Location %c (%s)\n",
                                            statstr, rcs_status[predim - 1], toupper(lasthc),
                                                                   alias_rev_lookup(lasthc, 0));
                                       }
                                    }
				}                                
                                else if ( funcbits == EXTCODE )  {
			            char tmp[10], stmp[16];
			            sprintf(tmp, "%d", unit);
                                    bitmap = 1 << unit2code(unit);
				    if ( subunit == 0 )
				       stmp[0] = '\0';
				    else
				       sprintf(stmp, " subunit %02d", subunit);

                                    if ( xcmd == 0x31 )
                                       fprintf(fdsout, "%s rcvi function    xPreset : housecode %c unit %d%s level %d (%s)\n",
                                           statstr, hc, unit, stmp, xdata, alias_rev_lookup(hc, bitmap));
				    else if ( xcmd == 0x3b )
                                       fprintf(fdsout, "%s rcvi function    xConfig : housecode %c unit %d%s mode=%d (%s)\n",
                                           statstr, hc, unit, stmp, xdata, alias_rev_lookup(hc, bitmap));
                                    else if ( xcmd == 0x33 )
                                       fprintf(fdsout, "%s rcvi function     xAllOn : housecode %c\n",
                                           statstr, hc);
                                    else if ( xcmd == 0x34 )
                                       fprintf(fdsout, "%s rcvi function    xAllOff : housecode %c\n",
                                           statstr, hc);
                                    else if ( xcmd == 0x37 ) {
                                       if ( (xdata & 0x30) == 0 ) 
                                          fprintf(fdsout, "%s rcvi function xStatusReq : housecode %c unit %d%s (%s)\n",
                                              statstr, hc, unit, stmp, alias_rev_lookup(hc, bitmap));
                                       else if ( (xdata & 0x30) == 0x10 )
                                          fprintf(fdsout, "%s rcvi function    xStatus : POWER_UP houscode %c unit %d%s (%s)\n",
                                              statstr, hc, unit, stmp, alias_rev_lookup(hc, bitmap));
                                       else { 
                                          fprintf(fdsout, "%s rcvi function    xStatus : OTHER housecode %c unit %d%s data=0x%02x (%s)\n",
                                              statstr, hc, unit, stmp, xdata, alias_rev_lookup(hc, bitmap));
                                       }
                                    }
                                    else if ( xcmd == 0x38 ) {
                                       if ( xdata & 0x40 )
                                           fprintf(fdsout, "%s rcvi function    xStatus : Switch %c%d%s is %-3s %s (%s)\n",
                                               statstr, hc, unit, stmp, ((xdata & 0x3f) ? "On " : "Off"),
                                               ((xdata & 0x80) ? "LoadOK" : "NoLoad"), 
                                               alias_rev_lookup(hc, bitmap));
                                       else
                                           fprintf(fdsout, "%s rcvi function    xStatus : Lamp %c%d%s at level %d, %s (%s)\n",
                                               statstr, hc, unit, stmp, xdata & 0x3f, 
                                               ((xdata & 0x80) ? "BulbOK" : "NoBulb"), 
                                               alias_rev_lookup(hc, bitmap));
                                    }
                                    else if ( xcmd == 0xff )
                                       fprintf(fdsout, "%s rcvi function    ExtCode : Incomplete xcode in buffer.\n",
                                               statstr);
                                    else  {
                                       fprintf(fdsout, "%s rcvi function   xFunc %02x : housecode %c unit %d%s data=0x%02x (%s)\n",
                                           statstr, xcmd, hc, unit, stmp, xdata, alias_rev_lookup(hc, bitmap));
                                    }
                                }
                                else {
				    fprintf(fdsout, "%s rcvi function %10s : housecode %c\n",
					statstr, func, hc);
                                    if ( funcbits == 8 && i_am_state && config.ack_hails == YES ) {
                                       acknowledge_hail();
                                    }
				}

			    }

                            if ( special_func > 0 ) {
                               if( (funcbits == PRESET1 || funcbits == PRESET2) ) {
                                  if ( lastunit > 10 ) {
                                     temperat = -60 + (predim - 1) + 32 * (lastunit - 11);
                                     fprintf(fdsout, "%s Temperature = %2d : Location %c (%s)\n",
                                          statstr, temperat, lasthc, alias_rev_lookup(lasthc, 0));
                                  }
                                  else if ( lastunit == 6 && predim < 9 ) {
                                     fprintf(fdsout, "%s %s : Location %c (%s)\n",
                                         statstr, rcs_status[predim - 1], toupper(lasthc),
                                                                   alias_rev_lookup(lasthc, 0));
                                  }
                               }
                            }
                        }
			else {		
                            /* an address bye was received */
			    hc = code2hc( ((buf[i] & 0xF0) >> 4) );
			    unit = code2unit( buf[i] & 0x0F) ;

                            bitmap = 1 << (buf[i] & 0x0f);
                            lasthc = hc;
                            lastunit = unit;
                            x10state_update_addr(buf[i]);
			    if( showdata )  {
			        char tmp[10];
			        sprintf(tmp, "%d", unit);
				fprintf(fdsout, "%s rcvi address unit    %3d : housecode %c (%s)\n",
					 statstr, unit, hc, alias_rev_lookup(hc, bitmap) );
			    }
			}

			fflush(fdsout);

			
                        if ( launchp >= 0 && i_am_state) {
                            launch_script(&launchp);
                        }
		    }
		    fflush(fdsout);
		}
	    }
	    else {
		if (verbose)
		    sprintf( statstr, "Bytes received = %d,", n);
		fprintf(fdsout, "%s The interface didn't answer a getinfo response.\n",
			statstr);
	    }
	}
        else if ( buf[0] == 0xa5 )  {
            /* CM11A is asking for time update */
	    fprintf(fdsout, "Module experienced a power failure. %s",
	            "It requested a time update.\n");
	}
	else if ( buf[0] == 0x5b ) {  
           /* The CM11A is reporting a macro execution */
	   to_read = 2;
	   n = xread(sptty, buf, to_read, timeout);
	   if ( showdata ) {
              mac_addr = ((buf[0] & 0x07) << 8) + buf[1];
              /* Get macro label (or "Unknown") and saved image checksum */ 
              maclabel = lookup_macro(mac_addr, &ichksum);

              if ( buf[0] & 0x70 ) {
                 /* The macro was executed by a Trigger */
                 if ( ichksum != -1 && load_image(ichksum) ) {

                    /* Determine and display the inferred trigger. */
                    /* Launch script if warranted.                 */
                    tag = (buf[0] & 0x70) >> 4;
                    signal_source = RCVT;
                    display_trigger(statstr, mac_addr, tag);

                    /* Announce the execution of the macro */
                    fprintf(fdsout, "%s Trigger executed macro   : %s, address %d\n",
                                       statstr, maclabel, mac_addr);

                    /* Decipher and display macro elements from image file. */
                    /* Launch script(s) if warranted.                       */
                    signal_source = SNDT;
                    expand_macro(statstr, mac_addr, TRIGGER_EXEC);
                 }
                 else {
                    fprintf(fdsout, "%s Trigger executed macro   : %s, address %d\n",
                                       statstr, maclabel, mac_addr);
                 }
              }  
              else  {
                 /* The macro was executed by a Timer */
                 if ( ichksum != -1 && load_image(ichksum) ) {

                    /* Announce the execution of the macro */
                    fprintf(fdsout, "%s Timer executed macro     : %s, address %d\n",
                                 statstr, maclabel, mac_addr);

                    /* Decipher and display macro elements from image file */
                    /* and launch script(s) if warranted.                  */
                    signal_source = SNDM;
                    expand_macro(statstr, mac_addr, TIMER_EXEC);
                 }
                 else {
                    fprintf(fdsout, "%s Timer executed macro     : %s, address %d\n",
                                       statstr, maclabel, mac_addr);
                 }
              }
           }
	}
	else if ( !(buf[0] == 0x55 && n == 1) )  {
            /* There's some sort of timing problem with the 0x55 ("ready to  */
            /* receive") signal from the interface after a long bright/dim   */
            /* or extended command is sent.  Ignore it, but alert to other   */
            /* unknown values.                                               */
	    fprintf(fdsout, 
	        "%s Poll received unknown value (%d bytes), leading byte = %0x\n",
		statstr, n, buf[0]);
        }

        fflush(fdsout);
    }
    return 0;
}

